﻿using Infragistics.Documents.Excel;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Security;
using System.Web;
using System.Web.Mvc;

namespace IG_ExcelLibrary_CS.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            this.ExportExcel();
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

        public void ExportExcel()
        {
            Workbook wb = new Workbook(WorkbookFormat.Excel2007);
            var ws = wb.Worksheets.Add("Sheet1");

            ws.GetCell("A1").Value = "January";
            ws.GetCell("B1").Value = "February";
            ws.GetCell("C1").Value = "March";
            ws.GetCell("D1").Value = "April";

            ws.GetCell("A3").Value = 10;
            ws.GetCell("B3").Value = 20;
            ws.GetCell("C3").Value = 30;
            ws.GetCell("D3").Value = 40;

            ws.GetCell("A5").Value = 15;
            ws.GetCell("B5").Value = 25;
            ws.GetCell("C5").Value = 23;
            ws.GetCell("D5").Value = 45;

            ws.GetCell("A7").Value = 13;
            ws.GetCell("B7").Value = 23;
            ws.GetCell("C7").Value = 39;
            ws.GetCell("D7").Value = 11;

            //Get the cells for the four charts that will placed in the Worksheet.
            WorksheetCell cell1 = ws.GetCell("E7");
            WorksheetCell cell2 = ws.GetCell("M30");
            
            //Create Line chart.
            WorksheetChart chart1 = ws.Shapes.AddChart(Infragistics.Documents.Excel.Charts.ChartType.Line, cell1, new Point(0, 0), cell2, new Point(100, 100));
            var axes = chart1.AxisCollection;
            chart1.SetSourceData("A1:D7", true);

            SendForDownload(wb, WorkbookFormat.Excel2007);
        }

        [SecuritySafeCritical]
        private void SendForDownload(Workbook document, WorkbookFormat excelFormat)
        {
            string documentFileNameRoot;
            documentFileNameRoot = string.Format("Document.{0}", excelFormat == WorkbookFormat.Excel97To2003 ? "xls" : "xlsx");

            Response.Clear();
            Response.AppendHeader("content-disposition", "attachment; filename=" + documentFileNameRoot);
            Response.ContentType = "application/octet-stream";
            document.SetCurrentFormat(excelFormat);
            document.Save(Response.OutputStream);
            Response.End();
        }
    }
}